%%%%%%%%%% Reinforcement Problem 10.15 %%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Lightly-damped modes ----
%
clear
disp('Reinforcement Problem 10.15')
% Problem P10.15
disp('P10.15 - Design full state and observer gain')
Ts = 0.1 
A = [ 0.9641     0.2462     0.0303; ...
     -0.2462     0.9641     0.1934; ...
      0          0          0.6065]
B = [ 0.0056;    0.0528;    0.3935]
C = [ 1 0 0]
D = 0
Gp = ss(A,B,C,D,Ts)
% (a) design full-state feedback and observer gains
p_s = [0.9159+j*0.2339 0.9159-j*0.2339 0.5762]'
F = place(A,B,p_s)
A_cl = A-B*F
p_o = [0.3 0.6 0.7]'
L = place(A',C',p_o)'
A_ob = A-L*C
eig(A_ob)
% (b) build observer-controller according to (10.5) and (10.6)
A_oc = A-B*F-L*C
Goc = ss(A_oc,-L,-F,0,Ts)
Goc_poles = pole(Goc);
[mag_Goc_poles,theta_Goc_poles] = xy2p(Goc_poles)
Goc_zeros = tzero(Goc)
figure, bode(Goc)
GpGc = Gp*Goc
Gcl = feedback(GpGc,1,-1)
cl_loop_poles = pole(Gcl)
% (c) pre-gain for unity DC gain
lfg = dcgain(Gcl)
N = 1/lfg
% incorporate N in series with closed-loop system transfer function 
T_ref = N*Gcl;
t = [0:Ts:10];
r = 0*t;
z0 = [1 0 -2 0 0 0]'   % initial condition
[y,t,z] = lsim(T_ref,r,t,z0);
figure
plot(t,z(:,1:3),'o',t,z(:,4:6),'+'), grid
[ys,t,z] = step(T_ref,t);
figure
step(T_ref,t)
%%%%%%%%%%