%%%%%%%%%%% Reinforcement Problem 2.1 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%	--- Third-order System ---
%
% Create G(z) as a TF object and determine some properties
clear
disp('Reinforcement Problem 2.1')
numG  = [1.25 -1.25 0.3]          % enter transfer function numerator
denG  = [1 -1.05 0.8 -0.1]        % ...and denominator polynomials
% Create G(z) as a discrete-time TF object with unspecified sampling period
G   = tf(numG,denG,-1)
get(G)                            % Show properties of the TF object
[nn,dd] = tfdata(G,'v')
%-- convert system from TF form to ZPK form
GG = zpk(G)					      % ZPK object
[zz,pp,kk] = zpkdata(GG,'v')      % zeros, poles, & gain from ZPK object
[mag_pp,theta_pp] = xy2p(pp)      % show poles in polar form
figure
ucircle						      % draw the unit circle
hold on
pzmap(GG)                         % draw pole-zero plot
hold off
set_xo_size					      % make larger X's and O's
text('Units','norm','Pos',[0.02,0.95],'Str','Reinforcement Problem 2.1')
%%%%%%%%%%