%%%%%%%%%%% Reinforcement Problem 2.17 %%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Complex poles on the unit circle ---
%
clear
disp('Reinforcement Problem 2.17')
clear
numG = [1 0.3]                  % generate G(z) as TF object
denG = [1 -2.4976 2.4232 -0.8796]
G = tf(numG,denG,1)             % sampling period = 1.0 s
[mag,theta] = xy2p(pole(G))     % magnitudes & angles of poles
k = 0:40;                       % define vector of time points
y = impulse(G,k);               % compute delta response of G(z)
figure
stem(k,y,'o');grid       
title('Impulse response for Reinforcement Problem 2.17')
xlabel('Time (s)')
%%%%%%%%%%