%%%%%%%%%%% Reinforcement Problem 2.5 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%	--- Third-order System ---
%
clear
disp('Reinforcement Problem 2.5')
% Do partial-fraction expansion and unit delta response
numG = [0.2 1.1 0.5];                % define numerator of G(z)
denG = [1 0.7 0.5 0.1];              % define denominator of G(z)
% Build G(z) as TF object with sampling time 1 s
G  = tf(numG,denG,1)              
[zz,pp,kk] = zpkdata(G,'v')          % zeros, poles, & gain of G(z)
[mag_pp,theta_pp] = xy2p(pp)	     % polar form of the poles
[rGoz,pGoz,otherGoz] = ...
		residue(numG,[denG 0])       % residues & poles of G(z)/z
[mag_rGoz,theta_rGoz] = xy2p(rGoz)   % residues in polar form
[y,k] = impulse(G);                  % compute unit delta response
figure
stem(k,y,'filled')                   % plot response
grid
title('Impulse Response for Reinforcement Problem 2.5')
%%%%%%%%%%