%%%%%%%%%%%%%%%%%%% wif2_3.m %%%%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Partial-fraction and g(k) ----
%
clear
disp('What if 2.3')
numG = [1 0.7 2.5];                           % define numerator of G(z)
denG = [1 -0.6728 0.0463 0.4860];             % define denominator of G(z)
[rGoz,pGoz,otherGoz] = residue(numG,[denG 0]) % residues & poles of G(z)/z

%-------- convert poles & residues to polar form -------
disp('polar form of the poles of G/z are:')
[mag_pGoz,theta_pGoz] = xy2p(pGoz)            % magnitudes & arguments of the poles   
disp('polar form of the residues of G/z are:')
[mag_rGoz,theta_rGoz] = xy2p(rGoz)            % magnitudes & arguments of the residues

G  = tf(numG,denG,1)                          % G(z) as TF object with Ts = 1 s
[y,k] = impulse(G);                           % compute unit delta response
stem(k,y,'filled')                            % plot response
grid
xlabel('Time (s)')
%%%%%%%%%%