%%%%%%%%%%% Reinforcement Problem 4.6 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Third-order system ----
%
clear
disp('Reinforcement Problem 4.6')
Ts = 0.1;
A =  [0.85  -0.56 0.22
      0.2    0.11   1
     -0.25   0.5    0];
B = [1 0 0]';
C = [0.58 -0.30 0.16];
D=0;

%----- build SS model
Gss = ss(A,B,C,D,Ts)
disp('SS object Gss')
disp('*******>'); pause

%----- convert from SS form --> ZPK form
Gzpk = zpk(Gss)
disp('ZPK object zpk')
disp('*******>'); pause

%----- extract zeros, poles, gain from ZPK object
[z,p,k] = zpkdata(Gzpk,'v')
disp('zeros, poles, gain from ZPK object')
disp('*******>'); pause

%----- compare with results from these cmds
zz = tzero(Gss)
pp  = pole(Gss)
disp('zeros from tzero cmd on SS object and')
disp('.......poles from pole cmd on SS object')
disp('*******>'); pause

disp('eigenvalues of A are:')
disp(eig(A))

%---- do a PZ map
figure
ucircle
axis equal
hold on
pzmap(Gss)
hold off
title('Reinforcement Problem 4.6')
%%%%%%%%%%




