%%%%%%%%%%% Reinforcement Problem 7.1 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- ZPK model ----
%
clear
disp('Reinforcement Problem 7.1')
Ts = 0.1
Gs = tf(10,conv([1 0],[1 10]))   % plant in continuous TF form
Gz = c2d(Gs,Ts,'zoh')            % discretize plant with ZOH
Gc = tf([1 -0.5],[1 -0.8],Ts)    % discrete controller
T = feedback(Gz*Gc,1)            % CL system
[wn,zeta,pp] = damp(T);
wn
zeta
[mag_pp,theta_pp] = xy2p(pp);
[y,t] = step(T);
[Mo,tp,tr,ts,ess] = kstats(t,y,1)
%%%%%%%%%%
